#include "Stack.h"

Node* createNode(Data newData)
{
	Node* pMem = malloc(sizeof(Node));

	if (pMem != NULL)
	{
		// we allocated space for a Node

		// let's init it
		pMem->item = newData;
		pMem->pNext = NULL;
	}

	return pMem;
}

int isEmpty(const Stack* pStack)
{
	return pStack->pTop == NULL; // pStack->pTop
}

// precondition: stack must not be empty!
Data peek(const Stack* pStack)
{
	return pStack->pTop->item;
}

int push(Stack* pStack, Data newData) // just like an insertAtFront () into a List
{
	int success = 0;

	Node* pMem = createNode(newData);

	if (pMem != NULL)
	{
		// createNode *( was successful
		success = 1;

		pMem->pNext = pStack->pTop;
		pStack->pTop = pMem;
	}

	return success;
}

// precondition: stack must not be empty!
void pop(Stack* pStack) // just like an deleteAtFront () from a List
{
	Node* pTemp = pStack->pTop;

	pStack->pTop = pTemp->pNext;

	free(pTemp);
}
