/*
	This example illustrates how to design, implement, and apply stack data structure.

	We are building this example to apply a stack to reverse a string. It's a very standard
	stack example. We'll also explore testing in this example.

	History: 2/7/24 - Completed one test case for push (). Implemented the application 
	                  function for reversing a string (reverseString ()) using our
					  stack data structure.
	
	         2/5/24 - Defined the Data, Node, and Stack structs. Implemented
	                  createNode (), isEmpty (), peek (), push (), and pop () functions for a
					  stack. Started writing a test case for push (), when the stack is empty.
					  We'll continue with this example on Wed, 2/7.
*/

#include "Stack.h"
#include "TestStack.h"
#include "ReverseString.h"

int main(void)
{
	testPushOnEmptyStack();

	//char* str = reverseString("cat"); // using a string literal will NOT work for 
	                                    // our argument, since our reverseString ()
	                                    // modifieds the original memory in which the 
	                                    // string is placed
	char testString[50] = "cat";
	printf("str: %s\n", testString);
	char* str = reverseString(testString);
	printf("rev str: %s\n", str);

	return 0;
}